// mtguru1.cpp : Defines the entry point for the DLL application.
//
#define WIN32_LEAN_AND_MEAN  // Exclude rarely-used stuff from Windows headers
#include "stdafx.h"

#define MT4_EXPFUNC __declspec(dllexport)

#define msg(m) MessageBox(NULL,m,"",NULL)

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MT4_EXPFUNC int __stdcall gFileOpen(char *file_name,int mode)
  {
   HANDLE hFile;
   DWORD dwDesiredAccess;
	switch(mode)
   {
   case 1:
	   dwDesiredAccess=GENERIC_READ;
	   break;
   case 2:
	   dwDesiredAccess=GENERIC_WRITE;
	   break;
	case 3:
	   dwDesiredAccess=GENERIC_ALL;
	   break;

   }

 
	hFile = CreateFile(file_name,    
                   dwDesiredAccess,
                   FILE_SHARE_READ, 
                   NULL,
                   OPEN_ALWAYS,
                   FILE_ATTRIBUTE_NORMAL,
                   NULL);
	return((int)hFile);
  }

MT4_EXPFUNC int __stdcall gFileClose(int handle)
{
	return (CloseHandle((HANDLE)handle));

}

MT4_EXPFUNC int __stdcall gFileWrite(int handle,const char *data)
{
	DWORD dwWritten;

	int result =  WriteFile((HANDLE) handle,
						data,
						lstrlen(data),
						&dwWritten,
						NULL);

	return (result);

}

MT4_EXPFUNC char* __stdcall gFileRead(int handle,int length=0)
{
	DWORD		dwRead	= 0;
	char pBuffer[1024];
	
	int result =  ReadFile(
						(HANDLE) handle,
						pBuffer,
						length,
						&dwRead,
						NULL);

	pBuffer[strlen(pBuffer)]='\0';

	return (pBuffer);

}

MT4_EXPFUNC void __stdcall gFileSeek(int handle,int offset, int mode)
{

	SetFilePointer((HANDLE) handle,offset, NULL, mode ); 

}

MT4_EXPFUNC bool __stdcall gFileDelete(char* file_name)
{

	return (DeleteFile(file_name));
 
}

MT4_EXPFUNC int __stdcall gFileSize(int handle)
{

	return (GetFileSize((HANDLE) handle,NULL));
  
}